//###########################################################################//
//
//Project :   Timer  v 1.00  for Ti 92+
//
//Author:  David Coz      
//
//Mail  :  coz.hubert@infonie.fr
//
// Set some timers values...
//
// Created 25/06/2002; 21:00:59
//
//############################################################################//


#define USE_TI92PLUS        

#define OPTIMIZE_ROM_CALLS // Use ROM Call Optimization

#define NO_EXIT_SUPPORT

#include <tigcclib.h>         // Include All Header Files

#define message(s) {ST_showHelp (s); return;}


int choice;
// Contain your Values
int apd=500,krt=336,bkt=48;


// Int to String routine,with 3 digits
char *IntToStr (unsigned long an_integer)
{
  static char result [] = "   \0";    
	unsigned long x=an_integer;
  char *ptr = result + 3;
  while (an_integer)
    {
      *ptr-- = an_integer % 10 + '0';
      an_integer/=10;
    }
    if (x<100) *ptr-- = '0';
    if (x<10) *ptr-- = '0';
    if (x==0) *ptr-- = '0';
     
      return ptr;
}


// Main Function
void _main(void)
{
// Check if a parameter is given
int mode=0;
ESI argptr = top_estack;
mode = GetIntArg (argptr);

if (mode)
{
// if the parameter = 1,sst automatically the preferences...
OSFreeTimer (APD_TIMER);
OSRegisterTimer (APD_TIMER, apd*20);
OSInitKeyInitDelay (krt);
OSInitBetweenKeyDelay (bkt);
message("Preferences set...");
}

/***  TIMER  CHOICE  *********************************/

int buffer[1],defaut,val,entry;
buffer[0]=1;
	HANDLE handle0 = PopupNew (NULL, 40);
	PopupAddText(handle0,-1,"APD Timer",1);
	PopupAddText(handle0,-1,"Key Repeat Timer",2);
	PopupAddText(handle0,-1,"Between Key Timer",3);
	HANDLE handle2 = DialogNewSimple (170, 55);

	DialogAddTitle (handle2, "Coz David <coz.hubert@infonie.fr>", BT_OK, BT_CANCEL);
DialogAddText (handle2,13,18,"Choose a Timer...");
DialogAddPulldown (handle2,13,30,"Choice", handle0,0);
if (DialogDo (handle2, CENTER, CENTER, NULL,buffer)==KEY_ESC)
{
	HeapUnlock (handle2);
	HeapFree (handle2);
	HeapUnlock (handle0);
	HeapFree (handle0);
return;
}
	HeapUnlock (handle2);
	HeapFree (handle2);
	HeapUnlock (handle0);
	HeapFree (handle0);
	choice=buffer[0];


// Set the default and your previous entry,depending 
// on the timer you choose

if (choice==1)
{
defaut=500;
entry=apd;
}
if (choice==2)
{
defaut=336;
entry=krt;
}
if (choice==3)
{
defaut=48;
entry=bkt;
}

/*******   INPUT YOUR TIMER VALUE *************************/

val=0;
char buf[50],str[50];

// 'str' contains the default value information
sprintf (str,"Default Value : %d",defaut);

// You must entry something greater than 5,for security
while (val<5)
{
strcpy(buf,IntToStr(entry));
handle2 = DialogNewSimple (170, 55);
DialogAddTitle (handle2, "Coz David <coz.hubert@infonie.fr>", BT_OK, BT_CANCEL);
DialogAddRequest (handle2, 3, 18, "Timer Value`", 1, 3, 8);	
DialogAddText (handle2, 3, 30,str);

DialogDo (handle2, CENTER, CENTER, buf, NULL);
HeapUnlock (handle2);
HeapFree (handle2);
val=atoi(buf);	
}


// Set the Timers to your value 


if (choice==1)
{
apd=val;
OSFreeTimer (APD_TIMER);
OSRegisterTimer (APD_TIMER, val*20);
}		
if (choice==2)
{
OSInitKeyInitDelay (val);
krt=val;
}
if (choice==3)
{
OSInitBetweenKeyDelay (val);
bkt=val;
}		

message("Preferences set...");
	
}
